	Subroutine CRONO(npts,kpo,lpsb)

!       Filtrage des series chronologiques
!       Appel de ELFIL et analyses diverses de ses sorties

!       Auteur: M. Feissel-Vernier <feissel@ensg.ign.fr>
!       Juillet 2002   

	Implicit none
	Integer*4   NF,Nsp,Ncc,Nst,NIC
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)
	Parameter (Nsp=1000)  ! Nb de pts du spectre (spfil.f)
	Parameter (Ncc=1000)  ! Nb de cycles sur la duree totale 
	Parameter (Nst=1000)   ! Nb de variances d'Allan (common STAT)
	Parameter (NIC=12)    ! Nb max d'inconnues pour MCGAUSS

      	Real*8    datav,t_date(NF)
      	Real*4    teru,t_SERI(NF),t_GERI(NF),t_TEND(NF),t_SAIS(NF),
	1         poids(NF),biais,pente,pctd,trud
	Integer*4 J,kpt,ks,kt,L,npts

!       Declarations pour recevoir les donnees a analyser et retourner les ajouts

	Character*6  nom_var            ! nom de l'unite en sortie
      	Real*8       date,djou
      	Real*4       tref,geri,ajou
	Integer*4    itrou,kpo
	COMMON/DONNEES/date(NF),nom_var,tref(NF),geri(NF)
	COMMON/AJOUS/djou(NF),ajou(NF),itrou

!                Interface avec ELFIL

      	Real*4    BP,BI,belim,DATDEP,  SERI,TEND,SAIS,SAISb,REST 
	Integer*4 Limp,lpair,kbcl,LPS, INTERU,NTOT
	COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NTOT
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),SAISb(NF),REST(NF)

!                Supplement pour ELFIL2

	Integer*4 lpsb

!                Interface avec SPFIL 

      	Real*4       resp(NF),TJ2000,frq,amp,samp,pt,perinf,persup
	Integer*4    NR,num
	COMMON/SPECTRES/frq(Nsp,2),amp(Nsp,2),samp(Nsp,2),NR(2),pt(NF),
	1               perinf(2),persup(2)

!                Pour MCGAUSS

	Real*8    ARG,A,YZ
	Real*4    sigma,R,SIG,XS,cc,pg
	Integer*4 neq,ninc
	Common/CACH/A(NF,NIC),YZ(NF),sigma,R(NF),
	1           SIG(NIC),XS(NIC),cc(NIC,NIC)

!                Pour transmettre en retour les variations du cyclique

c	Real*4    datecy,cyc,scyc,deb,fin,DIVERSIG

	Real*8    datecy
	Real*4    cyc,scyc,deb,fin,DIVERSIG
	Integer*4 I,ncy,NS
	Common/CYCL/datecy(Ncc,2),cyc(Ncc,2,2),scyc(Ncc,2,2),ncy(2),NS

!                Pour recevoir les stat de NETCENT

      	Real*8      dlim
      	Real*4      elim,centre,ecmax,fac
	Integer*4   nlim
	COMMON/ELIMS/dlim(NF),elim(NF),nlim,centre,ecmax,fac

!                Pour transmettre en retour les stat de VARBRUIT
!        0         0         0         0         0         0         *72*

	Real*4    biastend,pentend,spentend,pent,sent,rms_rest,pv,
	1         chi_rest,tz,vz,rr(NF),pr(NF),prest(NF),pcy
	Integer*4 nvz,kab
	Common/STAT/pcy(3),kab,biastend,pentend,spentend,pent(7),sent(7),
     .              tz(Nst,7),vz(Nst,7),nvz(7),rms_rest,chi_rest,pv(NF)
!       1: tend+rest; 2:tend;  3: rest;    
!       4: ampl_saisA1; 5: ampl_saisA2; 6: ampl_saisB1; 7: ampl_saisB2

c	type*,' CRONO:', npts,' mesures recues,',date(1),date(npts)

c	write(16,1)
 1	format(78('-')/'CRONO')
	
	ntot=npts

	do 1001 I=1,ntot
	poids(I)=1.
	if(geri(I).ne.0) poids(I)=1./geri(I)**2.
 1001	continue

	datdep=date(1)        ! les dates sont donnes en MJD

!       Intervalle tabulaire, limp (tend) et lps (saisA, saisB) en jours

	teru= (date(ntot)-date(1))/(tref(ntot)-tref(1))
	pctd=limp*teru
	pcy(1)=lps*teru    ! saisA
	pcy(2)=lpsb*teru   ! SaisB
	pcy(3)=kab*teru    ! Commensurabilite

	IF (NS.eq.0) THEN  ! Ondefinit une periode pour un pseudo-saisonnier
	   pcy(1)=0.1*(date(ntot)-date(1))
	   lps=pcy(1)/teru
	ENDIF

c	type*,'Interv. tab., sais, filtre tend:',teru,pcy,pctd,' d'

!       ------------------------------------------------------
	type*,'Elimination des valeurs aberrantes eventuelles'
!       ------------------------------------------------------

	CALL NETCENT(poids,ntot)

	type*,'Centrage:',centre,' ',nom_var,
	1     '  |ecart max|:',ecmax,' ',nom_var

!       On corrige la serie centree de sa pente globale
!       -----------------------------------------------

	neq=0
	do 253 L=1,ntot
	   neq=neq+1
           A(neq,1)=1.d0
           A(neq,2)=date(L)-date(ntot/2)
           YZ(neq)=seri(L)	
 253	continue
	ninc=2

	CALL MCGAUSS(Neq,Ninc)

	biais=XS(1)  
	pente=XS(2)

	do 254 L=1,ntot
	   seri(L)=seri(L)-biais-pente*(date(L)-date(ntot/2))
 254	continue

	type*,'Biais-pente enleve:',
	1      biais,' ',nom_var,pente,' ',nom_var,'/d'

	type*,'Premier passage d''Elfil (serie a trous)'
!       ------------------------------------------------

	interu=1                  ! intervalle naturel

	CALL ELFIL     ! Filtrage preliminaire pour combler les trous

!       --------------------------------------------------------
!       On comble les trous de la srie  partir de Tend et Sais
!       --------------------------------------------------------

	type*,'Comblement des trous'
c	write(6,15) 
	write(16,15) 
 15	format(78('-')/'CRONO')
      
	itrou=0
	J=0
	kt=0
	datav=date(1)-teru
 100	J=J+1
c	if(itrou.gt.45) STOP
	if(J.gt.ntot) go to 150
 110	continue

c	if(J.gt.1) 
c	1    type*,'Intervalle:',J,date(J),datav,date(J)-datav-teru

	IF (DABS(date(J)-datav-teru).le.0.49d0 * teru) THEN

	   kt=kt+1
	   pt(kt)=1.
	   pv(kt)=1.
	   t_tend(kt)=tend(J)
	   t_sais(kt)=sais(J)
	   t_seri(kt)=seri(J)
	   t_geri(kt)=geri(J)
	   t_date(kt)=date(J)
	   datav=t_date(kt)
	   go to 100
	ELSE
	   itrou=itrou+1
 	   kt=kt+1
	   pt(kt)=0.
	   pv(kt)=0.
c	   t_tend(kt)=tend(J-1)
	   t_tend(kt)=tend(J-1)+
	1	      (tend(J)-tend(J-1))/(date(J)-date(J-1))

	   IF (J.lt.lps) THEN
	      t_sais(kt)=0
	      t_seri(kt)=tend(J-1)+
	1	         (tend(J)-tend(J-1))/(date(J)-date(J-1))
	   ELSE
	      t_sais(kt)=sais(J-1-lps)
	      t_seri(kt)=sais(J-1-lps)+ tend(J-1)+
	1	         (tend(J)-tend(J-1))/(date(J)-date(J-1))
	   ENDIF
!        0         0         0         0         0         0         |72

c	   if(J.lt.lps) t_sais(kt)=0. 
c	   if(J.ge.lps) t_sais(kt)=sais(J-1-lps)
c	   if(J.lt.lps) t_seri(kt)=tend(J-1)
c	   if(J.ge.lps) t_seri(kt)=tend(J-1)+sais(J-1-lps)

	   t_geri(kt)=0.
	   t_date(kt)=t_date(kt-1)+teru
	   datav=t_date(kt)
c	   type*,'Trou',itrou,':',J-1,date(J-1),' -',kt,t_date(kt)

	   djou(itrou)=t_date(kt)
	   ajou(itrou)=t_seri(kt)

c	   write(6,17)t_date(kt),t_seri(kt),kt,itrou 
c	   write(16,17)t_date(kt),t_seri(kt),kt,itrou 
 17	   format('Trou comble. Date:',f12.5,' Valeur:',f10.5,
	1	' ligne No',2i5)
	   go to 110
	ENDIF

 150	continue

	if(itrou.ne.0) write(6,16) itrou,ntot,kt
	write(16,16) itrou,ntot,kt
 16	format(i6,' trous combles dans la serie',
	1    i6,' =>',i6,' mesures')

	ntot=kt
	npts=ntot

	do 200 J=1,ntot
	   seri(J)=t_seri(J)	
	   geri(J)=t_geri(J)	
	   date(J)=t_date(J)	
c         write(6,46) J, date(J),seri(J),geri(J)
 46      format('##',i5,4f10.3)
 200	continue

!       ---------------------
!       Appel de Elfil/Elfil2
!       ---------------------

	IF (NS.eq.0) THEN
	   type*,'Elfil:',
	1	' pseudo-composante cyclique, periode',pcy(1),' d'
	   CALL ELFIL		       ! Filtrage final, sans cyclique

	   do  220 L=1,ntot
	      rest(L)=rest(L)+sais(L)
 220	   continue
	ENDIF


	IF (NS.eq.1) THEN
	   type*,'Elfil:',NS,' composante de periode',pcy(1),' d'
	   CALL ELFIL		       ! Filtrage final, une cyclique
	ENDIF


	IF (NS.eq.2) THEN
	   type*,'Elfil:',NS,' deux composantes de periodes',
	1	pcy(1),' et',pcy(2),' d'
	   CALL ELFIL2(lpsb,saisB)	! Filtrage final, deux cycliques      
	ENDIF


!       On retablit la pente enlevee avant les passages par Elfil/Elfil2
!       ----------------------------------------------------------------

	do 244 L=1,ntot
	   seri(L)=seri(L)+biais+pente*(date(L)-date(ntot/2))
	   tend(L)=tend(L)+biais+pente*(date(L)-date(ntot/2))
 244	continue

!       Pente finale de tendance + irregulier
!       -------------------------------------

	neq=0
	do 250 L=1,ntot
	   if(pt(L).eq.0.) go to 250   ! Pts ajoutes
	   neq=neq+1
! Poids
	   pg=1.
	   if(kpo.eq.1) pg=1./geri(L)

           A(neq,1)=1.d0*pg
           A(neq,2)=(date(L)-date(1))*pg
           YZ(neq)= (tend(L)+rest(L))*pg	
 250	continue
	ninc=2

	CALL MCGAUSS(Neq,Ninc)

	biastend=XS(1)
	pentend=XS(2)  
	spentend=SIG(2)

!       Ecart-type du reste
!       -------------------

	neq=0
	do 260 L=1,ntot
	   if(pt(L).eq.0.) go to 260
	   neq=neq+1
           pr(neq)=1.d0
           prest(neq)=rest(L)
 260	continue

	rms_rest=DIVERSIG(prest,pr,Neq,5,rr)     ! moyenne quadratique

!       ------------------------------------------
	type*,'Spectre de la tendance et du reste'
!       ------------------------------------------

	TJ2000=51544.03
	do 350 num=1,2

	   do 300 L=1,ntot
	      resp(L)=0	
 300	   continue

	   IF (num.eq.1) THEN        ! => Spectre de la tendance
	      perinf(num)=pctd                      ! largeur filtre tendance
	      persup(num)=0.33*(date(ntot)-date(1)) ! 1/3 longueur de la serie
	      NR(num)=100
	      if(Ntot.lt.250) NR(num)=FLOAT(NR(num))/2.5
	      IF(persup(num).gt.perinf(num)) THEN
!                On ne transfere tend => serie a analyser que si
!                persup > perinf, i.e. si la serie est assez longue 
!                comparee a la longueur du filtre de la tendance.
!                Sinon, au n'aura pas de spectre de la tendance.
	         do 305 L=1,ntot
	            resp(L)=tend(L)	
 305	         continue
	      ENDIF
	   ENDIF

	   IF (num.eq.2) THEN         ! => Spectre du reste
	      perinf(num)=1.9*teru
	      persup(num)=2*pctd
	      NR(num)=100
	      if(Ntot.lt.250) NR(num)=FLOAT(NR(num))/2.5
	      do 310 L=1,ntot
	         resp(L)=rest(L)	
 310	      continue
	   ENDIF

	   CALL SPFIL(Ntot,NR(num),TJ2000,date,resp,num)

 350	continue

	type*,'Amplitude cyclique(s)'

!       ------------------------------------------------------------------
!       Variation de l'amplitude du/des cyclique(s) et premire harmonique
!       ------------------------------------------------------------------

	IF (kab.eq.0) THEN
!                               1) cas non commensurable

	   DO 450 ks=1,NS ! saisA (NS=1) et eventuellement saisB (NS=2) 
	      if(ks.eq.1) kpt=lps
	      if(ks.eq.2) kpt=lpsb

c	      type*,ks,lps,lpsb,kpt,' <- KPT'

	      ncy(ks)=0
	      do 400 L=1,ntot,kpt
	         neq=0
c	         type*,'Crono 400',L,':',(L-1)+1,(L-1)+kpt
	         do 360 I=1,kpt
	            J=(L-1)+I
	            if(pt(J).eq.0.) go to 360
	            neq=neq+1
	            if(neq.eq.1) deb=date(J)
! Poids
		    pg=1.
		    if(kpo.eq.1) pg=1./geri(J)

                    ARG=(date(J)-date(1))*2.d0*3.1415927d0/pcy(ks)
		    ARG=DMOD(ARG,2.d0*3.1415927d0)
                    A(neq,1)=1.d0*pg
                    A(neq,2)=dSIN(ARG)*pg
                    A(neq,3)=dCOS(ARG)*pg
                    A(neq,4)=dSIN(2.d0*ARG)*pg
                    A(neq,5)=dCOS(2.d0*ARG)*pg
                    YZ(neq)= (seri(J)-tend(J))*pg	
	            fin=date(J)
 360	         continue
	         ninc=5

	         IF(neq.lt.10 .or. neq.lt.2*kpt/3) go to 400

	         CALL MCGAUSS(Neq,Ninc)

	         ncy(ks)=ncy(ks)+1  ! Nb de determ. d'ampl. pour cycle ks
	         datecy(ncy(ks),ks)=0.5*(fin+deb)
! Fondamentale
	         cyc(ncy(ks),ks,1)= SQRT((XS(2)**2)+(XS(3)**2))
	         scyc(ncy(ks),ks,1)=SQRT((SIG(2)**2)+(SIG(3)**2))
! Harmonique 1
	         cyc(ncy(ks),ks,2)= SQRT((XS(4)**2)+(XS(5)**2))
	         scyc(ncy(ks),ks,2)=SQRT((SIG(4)**2)+(SIG(5)**2))

 400	      continue ! L=1,ntot,kpt

 450	   CONTINUE    ! ks=1,NS: saisA (NS=1) et saisB (NS=2) 
	   
	ELSE
!                               2) cas commensurable (kab non nul, et NS=2)
	   kpt=kab
	   ks=2
	   ncy(ks)=0

	   do 500 L=1,ntot,kpt
	      neq=0

c	      Common/CACH/A(NF,NIC),YZ(NF),sigma,R(NF),
c	1                 SIG(NIC),XS(NIC),cc(NIC,NIC)
	      do 455 I=1,NF
		 YZ(I)=0.d0
		 do 454 J=1,NIC 
		    A(I,J)=0.d0
 454		 continue
 455	      continue

	      do 460 I=1,kpt
	         J=(L-1)+I
	         if(pt(J).eq.0.) go to 460
	         neq=neq+1
	         if(neq.eq.1) deb=date(J)
! Poids
		 pg=1.
		 if(kpo.eq.1) pg=1./geri(J)
! Constante
                 A(neq,1)=1.d0*pg
! SaisA1
                 ARG=(date(J)-date(L))*2.d0*3.1415927d0/pcy(1) 
		 ARG=DMOD(ARG,2.d0*3.1415927d0)
                 A(neq,2)=dSIN(ARG)*pg
                 A(neq,3)=dCOS(ARG)*pg
! SaisA2
                 A(neq,4)=dSIN(2.*ARG)*pg
                 A(neq,5)=dCOS(2.*ARG)*pg
! SaisB1
                 ARG=(date(J)-date(L))*2.d0*3.1415927d0/pcy(2) 
		 ARG=DMOD(ARG,2.d0*3.1415927d0)
                 A(neq,6)=dSIN(ARG)*pg
                 A(neq,7)=dCOS(ARG)*pg
! SaisB2
                 A(neq,8)=dSIN(2.*ARG)*pg
                 A(neq,9)=dCOS(2.*ARG)*pg
! Observation
                 YZ(neq)=(seri(J)-tend(J))*pg  	
		 if(neq.eq.120) trud=seri(J)-tend(J)

	         fin=date(J)
 460	      continue
	      ninc=9

	      IF(neq.lt.15 .or. neq.lt.2*kpt/3) go to 500

	      CALL MCGAUSS(Neq,Ninc)

	      ncy(ks)=ncy(ks)+1
	      ncy(1)=ncy(ks)

	      datecy(ncy(ks),ks)=0.5*(fin+deb)
	      datecy(ncy(1),1)=0.5*(fin+deb)

c	      if(ncy(ks).ge.14) write(6,666),ncy(ks),neq,ninc,
c	1	   2000.0d0+(0.5*(fin+deb)-51544.03d0)/365.2422d0,
c	1	   pcy(1),SQRT((XS(2)**2.)+(XS(3)**2.)),
c	1	          SQRT((XS(4)**2.)+(XS(5)**2.)),
c	1	   pcy(2),SQRT((XS(6)**2.)+(XS(7)**2.)),
c	1	          SQRT((XS(8)**2.)+(XS(9)**2.)),trud
 666	      format(3I4,7f7.1,e10.3)

	      ks=1              ! SaisA1, SaisA2

	      cyc(ncy(ks),ks,1)= SQRT((XS(2)**2.)+(XS(3)**2.))
	      scyc(ncy(ks),ks,1)=SQRT((SIG(2)**2.)+(SIG(3)**2.))

	      cyc(ncy(ks),ks,2)= SQRT((XS(4)**2.)+(XS(5)**2.))
	      scyc(ncy(ks),ks,2)=SQRT((SIG(4)**2.)+(SIG(5)**2.))

	      ks=2              ! SaisB1, SaisB2

	      cyc(ncy(ks),ks,1)= SQRT((XS(6)**2.)+(XS(7)**2.))
	      scyc(ncy(ks),ks,1)=SQRT((SIG(6)**2.)+(SIG(7)**2.))

	      cyc(ncy(ks),ks,2)= SQRT((XS(8)**2.)+(XS(9)**2.))
	      scyc(ncy(ks),ks,2)=SQRT((SIG(8)**2.)+(SIG(9)**2.))

 500	   continue
	ENDIF


!       ---------------------------------------------------------------------
!       Type de bruit de la tendance et du reste et de l'amplitude du 1 cycle
!       (variance d'Allan)
!       ---------------------------------------------------------------------

c	type*,'Variances d''Allan'

	CALL VARBRUIT(ntot,kpo,teru)   !,lpsb)
	
	return
	end
