         SUBROUTINE MCGAUSS(NEQ,NINC)                                           

      Implicit none

      Integer*4   NF,NIC
      Parameter (NF=50000)      ! Nb max d'equations
      Parameter (NIC=12)        ! Nb max d'inconnues

      Real*8      U(NIC,NIC),W(NIC,NIC),XX,Y
      Real*4      B(NIC),CALC,SQ                                     
      Integer*4   I,IJ,J,K,LN

      Real*8      T,X
      Real*4      SIGMA,R,SIG,A,CC
      Integer*4   NEQ,NINC
      COMMON/CACH/T(NF,NIC),X(NF),SIGMA,R(NF),
     .            SIG(NIC),A(NIC),CC(NIC,NIC) 
                                                                  
      DO 201 I=1,NINC
  201 B(I)=0.
C
C             1. T(NEQ,NINC) MATRICE DES EQUATIONS D'OBSERVATION
C                B(12)     SECONDS MEMBRES DE CES EQUATIONS
C             2. W(NEQ,NEQ) MATRICE NORMALE
C             3. U(NEQ,NEQ) MATRICE INVERSE
C      CC  MATRICE DE CORRELATION
C      X VECTEUR DES OBSERVQTIONS
C      A  VECTEUR SOLUTION
C      R  RESIDUS
C      SIG  INCERTITUDES SUR LA SOLUTION
C     SIGMA   RESIDU QUADRATIQUE MOYEN

C             EQUATIONS NORMALES

      DO 108  I=1,NINC
  108 B(I) = 0.
      DO 101  I = 1,NEQ
      DO 103 IJ=1,NINC
  103 B(IJ)=B(IJ)+T(I,IJ)*X(I)
  101 CONTINUE
C
C             MOINDRES CARRES.
C
      DO 11 I=1,NINC
      DO 10 J=1,NINC
      U(I,J)=0.0D0
   10 W(I,J)=0.0D0
   11 U(I,I)=1.0D0
      DO 12 I=1,NINC
      DO 12 J=1,NINC
      DO 12 K=1,NEQ
   12 W(I,J)=W(I,J)+T(K,I)*T(K,J)
      DO 16 K=1,NINC
      XX=W(K,K)
      IF(XX.EQ.0.)  GO TO 117
      DO 13 J=1,NINC
      W(K,J)=W(K,J)/XX
   13 U(K,J)=U(K,J)/XX
      DO 15 I=1,NINC
      IF(I.EQ.K) GO TO 15
      Y=W(I,K)
      DO 14 J=1,NINC
      W(I,J)=W(I,J)-Y*W(K,J)
   14 U(I,J)=U(I,J)-Y*U(K,J)
   15 CONTINUE
   16 CONTINUE
      DO 104 IJ=1,NINC
      SIG(IJ)=0
      A(IJ)=0
      DO 104 LN=1,NINC
  104 A(IJ)=A(IJ)+U(IJ,LN)*B(LN)
C
C             RESIDUS...DISPERSION...
C
      SQ=0
      DO 105 I=1,NEQ
      CALC=0
      DO 106 J=1,NINC
  106 CALC=CALC+A(J)*T(I,J)
      R(I)=X(I)-CALC
  105 SQ=SQ+R(I)*R(I)
      SIGMA=SQRT(SQ/(NEQ-NINC))
      DO 107 J=1,NINC
  107 SIG(J)=SIGMA*DSQRT(U(J,J))
         DO 110 I=1,NINC
         DO 110 J=1,NINC
 110  CC(I,J)=U(I,J)/DSQRT(U(I,I)*U(J,J))
      GO TO 119
  117 WRITE(6,118)  K,((W(I,J),I=1,NINC),J=1,NINC)
  118 FORMAT(//' DIVISEUR NUL DANS MCGAUSS',I6,/12(12F10.5/))
  119 CONTINUE
      RETURN
      END

