	Subroutine NETCENT(pt,ntot)

!       date,pt,ntot: dates, poids et nb de pts dans la serie 

!       Elimination des points aberrants et transmission de la mediane

!       On retourne la serie (SERI, DATE, PT) compactee, 
!       SANS les points aberrants (listes dans crono_gmt.echo)
!       Le nombre de points conserves est encore NTOT (valeur modifee)

	Implicit none
	Integer*4   NF
	Parameter (NF=50000)

      	Real*4      vmoy,DIVERSIG,sr(ntot),pr(ntot),rr(ntot),
	2           BINSUP,rabs(ntot),ref
	Integer*4   I,kt,ntot,ntor,nref

!       Declarations pour l'interface avec CRONO: seri, date,tref,pt

	Character*6 nom_var            ! nom de l'unite en sortie
      	Real*8      date,dlim
      	Real*4      SERI,TEND,SAIS,SAISb,REST, tref,geri,  
	1           pt(NF),elim,centre,ecmax,fac
	Integer*4   nlim
	COMMON/DONNEES/date(NF),nom_var,tref(NF),geri(NF)
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),SAISb(NF),REST(NF)
	COMMON/ELIMS/dlim(NF),elim(NF),nlim,centre,ecmax,fac
!        0         0         0         0         0         0         |72

!           Calcul de la moyenne

	if(ntot.gt.NF) stop 'NETCENT: trop de mesures'

c	write(6,1) 
	write(16,1)
 1	format(78('-')/'NETCENT   Eliminations avant analyse.')

c	type*,'NETCENT:', ntot,seri(1),seri(ntot)

        do 100 I=1,ntot
	   sr(I)=seri(I)
	   pr(I)=1
 100	continue
	ntor=ntot+1
	nlim=0

 150	continue
	ntor=ntor-1
	nref=0

	vmoy=DIVERSIG(sr,pr,Ntor,6,rr)            ! moyenne "ponderee" (0/1)
	ref=DIVERSIG(rr,pr,Ntor,5,rr)             ! ecart-type/vmoy

!        Recherche des points ayant |residu|> fac*ref

           do 260 I=1,ntor
	      IF (ABS(rr(I)).gt.fac*ref) THEN
	         pr(I)=0 
		 nlim=nlim+1
		 elim(nlim)=seri(I)
		 dlim(nlim)=date(I)
	         nref=nref+1
c	         write(6,2)  rr(I),fac,ref,nref,date(I),seri(I),nlim
	         write(16,2) rr(I),fac,ref,nref,date(I),seri(I),nlim
 2	         format('Res.:',f12.4,'>',f4.0,'*',f12.4,
	1	       ' Date:',i2,f12.4,'  Val.:',f12.4,i4)
c		 type*,'NETCENT:',nlim,dlim(nlim),elim(nlim)
	      ENDIF
 260	   continue

	   if(nref.eq.0) go to 300

!        On reforme la liste sans ces points

	   kt=0
	   do 290 I=1,ntor
	      if(pr(I).eq.0) go to 290
	      kt=kt+1

	      sr(kt)=sr(I)
	      pr(kt)=1.

	      seri(kt)=seri(I)
	      date(kt)=date(I)
	      tref(kt)=tref(I)
	      pt(kt)=pt(I)
 290	   continue

	   go to 150
 300	   continue

	ntot=ntot-nlim
	centre=DIVERSIG(sr,pr,Ntot,8,rr)          ! mediane "ponderee" (0/1)

        do 305 I=1,ntot
c	   if(I.ge.ntot-13)type*,I,date(I),1043.+(date(I)-51545.)/7.
	   rabs(I)=ABS(rr(I))
 305	continue

	ecmax=BINSUP(rabs,ntot,2)

	if(nlim.ne.0)
	1    type*,'   Eliminination (|ecart| >',fac,'*sigma):',
	2    nlim,' mesure(s)'

	return
	end
