
      SUBROUTINE SPFIL(NT,NP,XZR,XX,YY,itr)

!		  NT mesures, NP periodes

	Implicit none

	Integer*4   NF,Nsp,NIC
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)
	Parameter (Nsp=1000)  ! Nb de pts du spectre (spfil.f)
	Parameter (NIC=12)    ! Nb max d'inconnues pour MCGAUSS


        Real*8     XX(NT)
      	Real*4     XZR,YY(NT),PER(NP),                 !pds(NT),
	1          P1,P2,F2,FAS,FRQ,FRA,F,D,ARG,PRA
	Integer*4  I,itr,JJ,NT,NP

!                Pour MCGAUSS

	Real*8   A,YZ
	Real*4   sigma,R,SIG,XS,cc
	Common/CACH/A(NF,NIC),YZ(NF),sigma,R(NF),
     .              SIG(NIC),XS(NIC),cc(NIC,NIC)

!       Declarations pour l'interface avec CRONO

      	Real*4    fr,amp,samp,pt,Per1,Per2
	Integer*4 NR
	COMMON/SPECTRES/fr(Nsp,2),amp(Nsp,2),samp(Nsp,2),
	1               NR(2),pt(NF),per1(2),per2(2)

        p1=per1(itr)     ! itr=1: tend   itr=2: rest
        p2=per2(itr)

	WRITE(16,5)  P1,P2,NT,XX(1),XX(NT),np,XZR
    5 	FORMAT(78('-')/
     .          'SPFIL: Periodogramme (moindres carres):',F8.3,' ->',
	1 	F9.3,' jours'/I6,' mesures,',F9.2,' -',F9.2,',',
	2 	i4,' raies. Tzero=',F9.2)

	F2=1/P1
	FAS=(1./P2-1./P1)/NP

	DO 4  JJ=1,NP
           FRQ=F2+(JJ-1)*FAS      ! frquence en cycles/jours
           FRA=FRQ*365.2422       ! frquence en cycles/an
           PER(JJ)=1./FRQ         ! priode en jours
           PRA=PER(JJ)/365.2422   ! priode en annes
           F=6.283185/PER(JJ)

           DO 3  I=1,NT
c              pt(I)=PDS(I)
c              D=SQRT(PDS(I))
              D=SQRT(pt(I))
              ARG=(XX(I)-XZR)*F
              A(I,1)=D
              A(I,2)=D*SIN(ARG)
              A(I,3)=D*COS(ARG)
              YZ(I)=YY(I)*D
 3	   continue

	   CALL MCGAUSS(NT,3)

	   FR(JJ,itr)=FRQ          ! frquence en cycles/jours
           AMP(JJ,itr)=SQRT((XS(2)**2)+(XS(3)**2))
           SAMP(JJ,itr)=SQRT((SIG(2)**2)+(SIG(3)**2))

c           if (JJ.eq.NP) 
c     .          type*, itr,FR(JJ,itr),AMP(JJ,itr),SAMP(JJ,itr)

    4 CONTINUE
      RETURN
      END

