	Subroutine VARBRUIT(ntot,kpo,pjour)

!       Analyse par la variance de paire et identification du type de bruit

!       ntot:  nb de pts dans serie sans trous
!       pjour: intervalle tabulaire en jours
!       pcy:  periode du cyclique en jours (ncy: nb de pts serie avec trous)

!       Auteur: M. Feissel-Vernier <feissel@ensg.ign.fr>
!       Juillet 2002   

	Implicit none
	Integer*4   NF,Ncc,Nst,NIC
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)
	Parameter (Ncc=1000)  ! Nb de cycles sur la duree totale 
	Parameter (Nst=1000)  ! Nb de variances d'Allan (common STAT)
	Parameter (NIC=12)    ! Nb max d'inconnues pour MCGAUSS

	Character*9 ent(7)
      	Real*8      rv(NF)
      	Real*4      pjour,tau0,tau(Nst),varp(Nst),var(Nst),rc(NF)
	Integer*4   I,k,kh,ks,L,ntot,m,mvr,kpo  !,m_varp

!       Declarations pour l'interface avec CRONO: tend,rest,geri

      	Real*4    SERI,TEND,SAIS,SAISb,REST 
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),SAISb(NF),REST(NF)

	Character*6  nom_var            
      	Real*8       date
      	Real*4       tref,geri
	COMMON/DONNEES/date(NF),nom_var,tref(NF),geri(NF)

!       Declarations pour l'interface avec CRONO_VUE: br_tend,br_rest

!        0         0         0         0         0         0         *72*
	Real*4    biastend,pentend,spentend,pent,sent,rms_rest,
	1         chi_rest,call_chi,tz,vz,pcy,pv
	Integer*4 nvz,nchi,nboites,kpas,kab
	Common/STAT/pcy(3),kab,biastend,pentend,spentend,pent(7),sent(7),
     .              tz(Nst,7),vz(Nst,7),nvz(7),rms_rest,chi_rest,pv(NF)
!       1: tend+rest; 2:tend;  3: rest;    
!       4: ampl_saisA1; 5: ampl_saisA2; 6: ampl_saisB1; 7: ampl_saisB2

!       Pour transmettre en retour les variations du/des cyclique(s)

	Real*8    datecy,datav,t_datecy(Ncc),dpcy
	Real*4    cyc,scyc,t_cyc(Ncc,2,2)
	Integer*4 J,ncy,nvar,itrou(2,2),kt(2,2),NS
	Common/CYCL/datecy(Ncc,2),cyc(Ncc,2,2),scyc(Ncc,2,2),ncy(2),NS

!                Pour MCGAUSS

	Real*8   A,YZ
	Real*4   sigma,R,SIG,XS,cc
	Common/CACH/A(NF,NIC),YZ(NF),sigma,R(NF),
	1           SIG(NIC),XS(NIC),cc(NIC,NIC)

	Data ent/'Tout     ','Tendance ','Reste    ',
	1        'Sais A1  ','Sais A2  ','Sais B1  ', 'Sais B2  '/

C        Nst=100

c	type*,'VARBRUIT: ntot, pjour, pcy,NS',ntot,pjour, pcy,NS

	write(16,1)
 1	format(78('-')/'VARBRUIT: variances d''Allan et chi^2 du reste')

c	type*,'Varbruit - pcy:',pcy

!           Calcul du Chi_2 pour rest pondere

	nchi=0
	DO 50 I=1,ntot
	   if(pv(I).eq.0) go to 50  ! On saute les trous
	   nchi=nchi+1
	   if(kpo.eq.0) rc(nchI)=rest(I)
	   if(kpo.eq.1) rc(nchI)=rest(I)/geri(I)	   
 50	continue

	type*,'Calcul du chi^2'

	chi_rest=0.
	IF (nchi.gt.150) THEN
	   nboites=50
	   if(nchi.lt.500) nboites=FLOAT(nchi)/10.
	   kpas=1
	   chi_rest=CALL_CHI(rc,nchi,nboites,kpas)
	ENDIF

c	write(6,67) chi_rest
	write(16,67) chi_rest
 67	format('*** Chi^2 du reste:',f6.2,' ***')

!       Preparation de la serie des amplitudes du 1 cycle et 1/2 cycle
!       on comble les trous

	DO 300 ks=1,NS   ! ks=1: saisA;  ks=2:saisB

	   do 200 kh=1,2 ! la fondamentale et la 1ere harmonique

c	      type*,'Varbruit 200:ks, kh, ncy(ks)',ks, kh, ncy(ks)

	      itrou(ks,kh)=0
	      J=0
	      kt(ks,kh)=0
c	      datav=datecy(1,ks)-pcy(ks)/FLOAT(kh)
	      dpcy=pcy(ks)
	      if(kab.ne.0) dpcy=pcy(3)
	      datav=datecy(1,ks)-dpcy/FLOAT(kh)
 100	      J=J+1

	      if(J.gt.ncy(ks)) go to 150
 110	      continue

!             Test de l'intervalle entre deux dates avec amplitudes estimees

	      IF (DABS(datecy(J,ks)-datav-dpcy).le.0.5d0*dpcy) THEN
	         kt(ks,kh)=kt(ks,kh)+1

c	      if(J.eq.1.or.J.eq.ncy(ks)) type*,'-- ',
c	1     J,kt(ks,kh),datecy(J,ks)-datav-dpcy,0.5d0*dpcy

		 IF(kt(ks,kh).gt.NCC) THEN
		    type*,'** ERREUR'
		    type*, '** Augmenter la valeur du parametre Ncc',
	1		   ' dans les programmes suivants:'
		    type*, '** crono_vue.f   crono.f   varbruit.f'
		    type*, '** La valeur actuelle (',Ncc,
	1		   ') est trop faible'
		    STOP
		 ENDIF
	         t_cyc(kt(ks,kh),ks,kh)=cyc(J,ks,kh)
		 t_datecy(kt(ks,kh))=datecy(J,ks)
		 datav=t_datecy(kt(ks,kh))
		 go to 100
	      ELSE
		 itrou(ks,kh)=itrou(ks,kh)+1
		 kt(ks,kh)=kt(ks,kh)+1

		 IF(kt(ks,kh).gt.NCC) THEN
		    type*,'** ERREUR'
		    type*, '** Augmenter la valeur du parametre Ncc',
	1		   ' dans les programmes suivants:'
		    type*, '** crono_vue.f   crono.f   varbruit.f'
		    type*, '** La valeur actuelle (',Ncc,
	1		   ') est trop faible'
		    STOP
		 ENDIF

		 t_cyc(kt(ks,kh),ks,kh)=cyc(J-1,ks,kh)
		 t_datecy(kt(ks,kh))=t_datecy(kt(ks,kh)-1)+pcy(ks)
		 datav=t_datecy(kt(ks,kh))

c		 write(6,66)pcy(ks),t_datecy(kt(ks,kh)),
c	1	       t_cyc(kt(ks,kh),ks,kh),itrou(ks,kh)

		 write(16,66)pcy(ks),t_datecy(kt(ks,kh)),
	1	       t_cyc(kt(ks,kh),ks,kh),itrou(ks,kh)
 66		 format('Trou comble dans ampl. cyclique:',f10.3,' d',
	1	   2f12.4,i3)

		 go to 110
	      ENDIF

 150	      continue

c	      type*,'VARBRUIT:',ks,kh,pcy(ks),itrou(ks,kh)

 200	   continue	! kh: la fondamentale et la 1ere harmonique
 300	CONTINUE        ! ks=1: saisA;  ks=2:saisB

!           CALCUL DES VARIANCES DE PAIRE

	type*,'Variances d''Allan'

        do 500 k=1,5+2*(NS-1)
	   IF(k.le.3) THEN

	      type*,'   ',ent(k)
	      do 480 L=1,ntot
	         if(k.eq.1) RV(L)=seri(L)     !tend(L)+rest(L)		
	         if(k.eq.2) RV(L)=tend(L)		
	         if(k.eq.3) RV(L)=rest(L)		
 480	      continue
	      nvar=ntot
	      tau0=pjour

	   ELSE

	      IF (k.eq.4.or.k.eq.6) THEN

		 ks=(k-2)/2       ! ks=1: saisA;  ks=2:saisB
           
	         if(MOD(k,2).eq.0)
	1        type*,'   Amplitude cyclique(s)',
	2	       pcy(ks),.5*pcy(ks),' jours'

	         do 495 kh=1,2
	     
	            if(itrou(ks,kh).ne.0.and.MOD(kh,2).eq.0) 
	1	    WRITE(6,6)itrou(ks,kh)
 6	            format(i6,' trous combles dans serie des amplitudes')
		 
	            do 490 L=1,kt(ks,kh)
	    	       RV(L)=t_cyc(L,ks,kh)		
 490	            continue
	            nvar=kt(ks,kh)
	            tau0=pcy(ks)

c		    type*,ks,kh,kt(ks,kh),rv(1),rv(kt(ks,kh))

 495	          continue

	      ENDIF
	   ENDIF

	   CALL ALLAN(nvar,RV,Tau0,VARP,0)

c      	   if(k.eq.1) write(6,20) ent(k)                                       
      	   write(16,20) ent(k)                                       
   20 	   FORMAT(/2X,'VARIANCES D''ALLAN ',a/
	1	        8X,'TAU (d)',8X,'SIG'/)
      	   DO 1282 M=1,Nst
      	      IF(VARP(M).EQ.0) GO TO 1283
      	      TAU(M)=Tau0*2**(M-1)
      	      VAR(M)=VARP(M)*VARP(M)
      	      write(16,21)M, TAU(M),VARP(M)      
   21 	      FORMAT(i5,F10.2,F12.4)
 1282 	   CONTINUE
 1283 	   CONTINUE
      	   MVR=M-1   
!          nombre de varp caculees (on ne conserve pas la derniere)
	   nvz(k)=mvr

	   IF (mvr.gt.nst) THEN
	      type*,'Le parametre NST de crono_vue.f, crono.f et',
	1	    ' varbruit.f est <',mvr
	      STOP
	   ENDIF

!	Preparation des donnees pour le Common STAT

	   do 1307 M=1,mvr	!  M - les Taus 
! indexation
	      TZ(M,k)=tau(M)
	      VZ(M,k)=var(M)
c      	   if(k.eq.1) type*,'varbruit',k,M, TZ(M,k), VZ(M,k)                                  
 1307 	   CONTINUE

 500	continue
	return
	end
